#include <stdio.h>

#define MAX 10000

int find_index_linear_probe(int hash[], int tb_sz, int key, int* collision){
    *collision = 0;
    int index = key%tb_sz;
    if (hash[index] == -1){
        
        hash[index] = key;
        return index;
    }
    (*collision)++;
    int i = 1;
    while (i<=tb_sz){
        int new_index = (index+i)%tb_sz;
        if (hash[new_index] == -1){
            hash[new_index] = key;
            return new_index;
        }
        else{
            i++;
            (*collision)++;
        }
    }
    return -1;
}

void linear_probe(int size, int nums[], int count){
    int hash[size];
    for(int i=0; i<size; i++) hash[i] = -1;

    int num_collisions = 0;
    int* collisions;
    int collided = 0;
    collisions = &collided;
    for(int i=0; i<count; i++){
        int ind_lp = find_index_linear_probe(hash, size, nums[i], collisions);
        printf("%d ", ind_lp);
        num_collisions+=(*collisions);
    }
    printf("\n%d\n", num_collisions);
}

int find_index_quadratic_probe(int hash[], int tb_sz, int key, int* collision){
    *collision = 0;
    int index = key%tb_sz;
    if (hash[index] == -1){
        
        hash[index] = key;
        return index;
    }
    (*collision)++;
    int i = 1;
    while (i<=tb_sz){
        int new_index = (index+i*i)%tb_sz;
        if (hash[new_index] == -1){
            hash[new_index] = key;
            return new_index;
        }
        else{
            i++;
            (*collision)++;
        }
    }
    return -1;
}

void quadratic_probe(int size, int nums[], int count){
    int hash[size];
    for(int i=0; i<size; i++) hash[i] = -1;

    int num_collisions = 0;
    int* collisions;
    int collided = 0;
    collisions = &collided;
    for(int i=0; i<count; i++){
        int ind_lp = find_index_quadratic_probe(hash, size, nums[i], collisions);
        printf("%d ", ind_lp);
        num_collisions+=(*collisions);
    }
    printf("\n%d\n", num_collisions);
}

int findR(int n){
    if (n & 1)  n -= 2;
    else    n--;
    int i, j;
    for (i = n; i >= 2; i -= 2) {
        if (i % 2 == 0) continue;
        for (j = 3; j*j <= i; j += 2)
            if (i % j == 0) break;
        if (j*j > i)    return i;
    }
    return 2;
}

int find_index_double_hash_probe(int hash[], int tb_sz, int key, int* collision){
    *collision = 0;
    int index = key%tb_sz;
    if (hash[index] == -1){
        
        hash[index] = key;
        return index;
    }
    (*collision)++;
    int i = 1;
    int R = findR(tb_sz);
    while (i<=tb_sz){
        int new_index = (index+i*(R-(key%R)))%tb_sz;
        if (hash[new_index] == -1){
            hash[new_index] = key;
            return new_index;
        }
        else{
            i++;
            (*collision)++;
        }
    }
    return -1;
}

void double_hash_probe(int size, int nums[], int count){
    int hash[size];
    for(int i=0; i<size; i++) hash[i] = -1;

    int num_collisions = 0;
    int* collisions;
    int collided = 0;
    collisions = &collided;
    for(int i=0; i<count; i++){
        int ind_lp = find_index_double_hash_probe(hash, size, nums[i], collisions);
        printf("%d ", ind_lp);
        num_collisions+=(*collisions);
    }
    printf("\n%d\n", num_collisions);
}
int main(){
    int table_size;
    scanf("%d",&table_size);

    int nums[table_size];
    int count = 0, temp;

    do{
        scanf("%d", &temp);
        nums[count] = temp;
        count++;
    }while(getchar() != 10);

    linear_probe(table_size, nums, count);
    quadratic_probe(table_size, nums, count);
    double_hash_probe(table_size, nums, count);

}