#include<stdio.h>
#include<stdlib.h>

struct Node{
	int data;
	struct Node *left;
	struct Node *right;
	int height;
};

int height(struct Node *node){
	if (node == NULL)	return 0;
	return node->height;
}

int max(int a, int b){
	return (a > b)? a : b;
}

struct Node* newNode(int data){
	struct Node* node = (struct Node*)malloc(sizeof(struct Node));
	node->data = data;
	node->left = NULL;
	node->right = NULL;
	node->height = 1;
	return(node);
}

struct Node *rightRotate(struct Node *y){
	struct Node *x = y->left;
	struct Node *T2 = x->right;

	x->right = y;
	y->left = T2;

	y->height = max(height(y->left), height(y->right)) + 1;
	x->height = max(height(x->left), height(x->right)) + 1;

	return x;
}

struct Node *leftRotate(struct Node *x){
	struct Node *y = x->right;
	struct Node *T2 = y->left;

	y->left = x;
	x->right = T2;

	x->height = max(height(x->left), height(x->right)) + 1;
	y->height = max(height(y->left), height(y->right)) + 1;

	return y;
}

int getBalance(struct Node *node){
	if (node == NULL)	return 0;
	return height(node->left) - height(node->right);
}

struct Node* insert(struct Node* node, int data){
	if (node == NULL)	return(newNode(data));

	if (data < node->data)
		node->left = insert(node->left, data);
	else if (data > node->data)
		node->right = insert(node->right, data);
	else
		return node;

	node->height = 1 + max(height(node->left), height(node->right));

	int balance = getBalance(node);

	if (balance > 1 && data < node->left->data)
		return rightRotate(node);
	if (balance < -1 && data > node->right->data)
		return leftRotate(node);
	if (balance > 1 && data > node->left->data)	{
		node->left = leftRotate(node->left);
		return rightRotate(node);
	}
	if (balance < -1 && data < node->right->data){
		node->right = rightRotate(node->right);
		return leftRotate(node);
	}

	return node;
}

int countNodes(struct Node* root){
	if(root==NULL)	return 0;
	return countNodes(root->left) + countNodes(root->right) + 1;

}

int countNodesGreaterThanK(struct Node* root,int K){
	if(root==NULL)	return 0;
	if(root->data == K)	return countNodes(root->right);
	else if(root->data > K){
		int sum = countNodes(root->right)+1;
		sum += countNodesGreaterThanK(root->left,K);
		return sum;
	}
	else	return countNodesGreaterThanK(root->left,K);
}

void inorder(struct Node* node, int K){
    if (node == NULL)   return;
    inorder(node->left, K);
    if (node->data > K) printf("%d ", node->data);
    inorder(node->right, K);
}
 
int main(){
    struct Node *root = NULL;
    

    char user_choice;
    int user_data;
    struct node* result = NULL;
    int ans = 0;

    while(1){
        scanf("%c", &user_choice);

        switch(user_choice) {
            case 'i':
                scanf("%d", &user_data);
                root = insert(root, user_data);
                break;
            case 'c':
                scanf("%d", &user_data);
                ans = countNodesGreaterThanK(root, user_data);
                printf("%d\n", ans);
                inorder(root, user_data);
                printf("\n");
                break;
            case 'e':
                return 1;
        }
    }

    return 0;
}
